; pls note: if you wish to join files longer then 1Mb, increase heap size
; in PE-header of loader, ex. tlink32 -Hr:4194304

; TASM5:    tasm32 /iC:\make\lib /ml /m2 /z loader.asm
; TASM5:    tlink32 /Tpe /aa /c /x /Hr:8388608 loader,,, import32.lib
; WATCOM11: wrc loader.rc
; UPX0.92:  upx -9 --strip-relocs --overlay=strip loader.exe

loadersize = 3584
.386
.model flat, stdcall
.data
        nop
.code
include win.inc

FileNLen   = 0
ShowType   = 2
RLESize    = 4
Compress   = 8
Service    = 9
CmdLnLen   = 0Ah
PhysSize   = 0Ch
PackedSize = 10h
ReadBytes  = 14h
TestByte   = 18h
outhandle  = 1Ch
srcmem     = 20h
dstmem     = 24h
strModule  = 200h
OutFileName= 400h
RealOutName= 600h
Buffer     = 800h
CmdLine    = 900h
lastvar    = 1000h

start:  sub esp, lastvar
        lea esi, [esp+strModule]
        extern GetModuleFileNameA:PROC
        call GetModuleFileNameA, NULL, esi, 512
        extern CreateFileA:PROC
        call CreateFileA, esi, GENERIC_READ, FILE_SHARE_READ or FILE_SHARE_WRITE, \
                          NULL, OPEN_EXISTING, 0, NULL
        mov esi, eax
        inc eax
        jz exit

        extern SetFilePointer:PROC
        call SetFilePointer, esi, loadersize, 0, FILE_BEGIN
readloop:
        lea ebx, [esp+FileNLen]
        lea ebp, [esp+ReadBytes]
        extern ReadFile:PROC
        call ReadFile, esi, ebx, 20, ebp, NULL
        test dword ptr [ebp], -1
        jz short jzClose

        movzx eax, word ptr [esp+CmdLnLen]
        lea ebx, [esp+CmdLine]
        call ReadFile, esi, ebx, eax, ebp, NULL
        test dword ptr [ebp], -1
        jz short jzClose

        movzx eax, word ptr [esp+FileNLen]
        test eax, eax
        jz short jzClose
        lea ebx, [esp+OutFileName]
        call ReadFile, esi, ebx, eax, ebp, NULL
        test dword ptr [ebp], -1
jzClose:jz Close

        extern ExpandEnvironmentStringsA:PROC
        lea edi, [esp+RealOutName]
        call ExpandEnvironmentStringsA, ebx, edi, 200h

        call CreateFileA, edi, GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, \
                          FILE_ATTRIBUTE_HIDDEN, NULL
        mov [esp+outhandle], eax
        inc eax
        jz readloop

        extern GlobalAlloc:PROC
        mov eax, [esp+PackedSize]
        push eax
        call GlobalAlloc, GMEM_FIXED, eax
        test eax, eax
        mov ebx, eax
        jz short Close1
        pop edx
        mov [esp+srcmem], eax
        call ReadFile, esi, ebx, edx, ebp, NULL
        test dword ptr [ebp], -1
        jz short Close1

        mov eax, [esp+PhysSize]
        call GlobalAlloc, GMEM_FIXED, eax
        test eax, eax
        mov edi, eax
        mov [esp+dstmem], eax
        jz short Close1

        mov eax, ebx
        mov dl, byte ptr [esp+Compress]
        test dl, dl
        jz short NoCompress
        xor ecx, ecx
CopyLoop:
        mov al, [ebx]
        inc ebx
        stosb
        cmp al, dl
        jnz short SkipRLE
        dec edi
        mov eax, [ebx]
        mov cl, ah
fill:   stosb
        loopd fill
        inc ebx
        inc ebx
SkipRLE:dec dword ptr [esp+RLESize]
        jnz short CopyLoop
        mov eax, [esp+dstmem]

NoCompress:
        mov edi, [esp+outhandle]
        mov edx, [esp+PhysSize]
        extern WriteFile:PROC
        call WriteFile, edi, eax, edx, ebp, NULL
        test dword ptr [ebp], -1
        jz short Close1

        inc al  ; reset ZF
Close1: pushf
        call CloseHandle, edi
        popf
        jz short rd1

        extern GlobalFree:PROC
        call GlobalFree, dword ptr [esp+srcmem]
        call GlobalFree, dword ptr [esp+dstmem]

        extern ShellExecuteA:PROC
        lea ecx, [esp+CmdLine]
        movzx eax, word ptr [esp+ShowType]
        lea edi, [esp+RealOutName]
        call ShellExecuteA, NULL, NULL, edi, ecx, NULL, eax
rd1:    jmp readloop

Close:  extern CloseHandle:PROC
        call CloseHandle, esi

        extern ExitProcess:PROC
exit:   call ExitProcess, 0
        end start